#include <windows.h>
#include <stdio.h>
#include <string.h>

void *
memfrob (void *s, size_t n)
{
  char *p = (char *) s;

  while (n-- > 0)
    *p++ ^= 42;

  return s;
}

LPVOID msg(void) {
	LPVOID lpMsgBuf;
	FormatMessage( 
	    FORMAT_MESSAGE_ALLOCATE_BUFFER | 
	    FORMAT_MESSAGE_FROM_SYSTEM | 
	    FORMAT_MESSAGE_IGNORE_INSERTS,
	    NULL,
	    GetLastError(),
	    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
	    (LPTSTR) &lpMsgBuf,
	    0,
	    NULL );
	return lpMsgBuf;
}

int main(int argc, char **argv) {
	HANDLE hFile;
	HANDLE hMM;
	PVOID pBuf;
	DWORD dwSize;

	if (argv[1] == 0) {
	    printf("usage : %s file_to_encode\n", argv[0]);
	    exit(1);
	}
	hFile = CreateFile(argv[1],
		GENERIC_READ|GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if (hFile == (HANDLE)0xffffffff) {
	    printf("%s file open error %s\n",argv[1],msg());
	    exit(1);
	}
	dwSize = GetFileSize(hFile, 0);
	if (dwSize == 0) {
		printf("file size is 0\n");
		exit(1);
	}
	hMM = CreateFileMapping(hFile,0,PAGE_READWRITE,0,0,0);
	if (hMM == 0) {
	    printf("%s file mapping error %s\n",argv[1],msg());
	    exit(1);
	}
	pBuf = MapViewOfFile(hMM,FILE_MAP_WRITE,0,0,0);
	if (pBuf == 0) {
		printf("MMap error %s\n",msg());
		exit(1);
	}
	memfrob(pBuf,dwSize);
	CloseHandle(hMM);
	CloseHandle(hFile);
	return 0;
}
